您的位置:首页 > 其它

Leetcode 375. Get Number Higher or Lower II

2018-04-09 23:28 323 查看

-题目

We are playing the Guess Game. The game is as follows:

I pick a number from 1 to n. You have to guess which number I picked.

Every time you guess wrong, I’ll tell you whether the number I picked is higher or lower.

However, when you guess a particular number x, and you guess wrong, you pay $x. You win the game when you guess the number I picked.

Example:

n = 10, I pick 8.

First round:  You guess 5, I tell you that it's higher. You pay $5.
Second round: You guess 7, I tell you that it's higher. You pay $7.
Third round:  You guess 9, I tell you that it's lower. You pay $9.

Game over. 8 is the number I picked.

You end up paying $5 + $7 + $9 = $21.


Given a particular n ≥ 1, find out how much money you need to have to guarantee a win.

题目的意思就是给定一个数字n,猜从1到n中间的一个数字,猜错则给对应金额的起钱,求保证猜对所花的最小钱数.

-思路

这道题的思路和之前刷的一道burst balloon有点相似,是需要用区间的想法来迭代(因为必须要分成左右两种情况,不能直接用一维的dp去理解)。

状态是用一个二维数组来表示,dp[i][j]表示在i到j之间猜中数字需要花费的最小钱数,dp[1]
表示最后所求的结果。

状态转移方程用以下思路推出,如果猜中数字,那么在i到j区间需要花费的最小钱数就是当前dp值,如果没有猜中,那么花费的钱数就是当前猜的金额k(k在[i,j]之间)加上猜左半部分(小于)或右半部分(大于)。由于我们要求的是最小保证胜利的金额,因此对猜中i和没猜中的情况列出状态转移方程:dp[i][j] = min(dp[i][k-1],dp[k+1][j]).

但是我能想到的数组的初始化稍稍有点复杂,因为i=j时猜中不需要花钱,所以dp[i][i]的值为0,同时将j

-代码

class Solution {
public:
int getMoneyAmount(int n) {
vector<vector<int> > dp(n+1, vector<int>(n+1,INTMAX-n));
dp[1][1]=0,dp[1][2]=1,dp[1][3]=2;
for(int i = 0; i < n; i++) {
for(int j = 0; j <= i; j++) {
dp[i][j]=0;
}
}
for(int k = 1; k < n; k++) {
for(int l = 1; l <= n-k; l++) {
int r = l + k;
for(int i = l + 1; i < r; i++) {
dp[l][r] = min(dp[l][r], i+max(dp[l][i-1], dp[i+1][r]));
}
}
}
return dp[1]
;
}
};
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode